
// see main 2divx.cpp for copyright and author information.

#include "Config.h"
#include "FileExist.h"


cBMM::cBMM()
{
    int i;
    for (i=0; i<MaxBMM; i++)
    {
	CDSize[i]=0;
	NumCDs[i]=0;
	Files[i]=0;
	MVR_MP3[i]=0;
	MVR_AC3[i]=0;
    }	
	Columns=0;
	Columns_MP3=0;
	Columns_AC3=0;
}

cBMM::~cBMM()
{
}

cDebug::cDebug()
{
    skip_dsjar=false;
    skip_lame=false;
    skip_mencoder=false;
    nodelete=false;
}

cDebug::~cDebug()
{
}

cConfig::cConfig()
{
 // Set some valid values for variables... most likely to fit !?
    DefaultBitrate=1380;
    TempDir="/tmp/vdr2divx"; // hope that's okay for all systems ?
    VDRroot="/video0";
    DstDir="/tmp/movies"; // in case no DstDir is specified in 2divx.conf

    Java="java";	// in case it's in path 
    DsJar="ds.jar";	// in case it's in path (i doubt that ;-)
    Lame="lame";	// in case it's in path
    Mencoder="mencoder"; //in case it's in path
}

cConfig::~cConfig()
{
}

void cConfig::Dump()
// Dumps all parameters in current class)
{
  int i;
  cout << "Configuration Dump, okay you asked for it ;-)\n";
  cout << "Bitrate Media Matrix (BMM):\nCDSize  :\t";
  for (i=0; i<BMM.Columns; i++)
    cout << BMM.CDSize[i] << "\t";
  cout << "\nNumCDs  :\t";
  for (i=0; i<BMM.Columns; i++)
    cout << BMM.NumCDs[i] << "\t";
  cout << "\nFiles   :\t";
  for (i=0; i<BMM.Columns; i++)
    cout << BMM.Files[i] << "\t";
  cout << "\nMVR_MP3 :\t";
  for (i=0; i<BMM.Columns_MP3; i++)
    cout << BMM.MVR_MP3[i] << "\t";
  cout << "\nMVR_AC3 :\t";
  for (i=0; i<BMM.Columns_AC3; i++)
    cout << BMM.MVR_AC3[i] << "\t";
  cout << "\n";
  cout << "Debug Modes:\n";
  cout << "skip_dsjar: " << Debug.skip_dsjar << " ( 0 = false / 1 = true )\n";
  cout << "skip_lame: " << Debug.skip_lame << " ( 0 = false / 1 = true )\n";
  cout << "skip_mencoder: " << Debug.skip_mencoder << " ( 0 = false / 1 = true )\n";
  cout << "nodelete: " << Debug.nodelete << " ( 0 = false / 1 = true )\n";
  cout << "\n";
  cout << "DefaultBitrate: " << DefaultBitrate << "kbits/s\n";
  cout << "Java: \"" << Java << "\"\n";
  cout << "DsJar: \"" << DsJar << "\"\n";
  cout << "Lame: \"" << Lame << "\"\n";
  cout << "Mencoder: \"" << Mencoder << "\"\n";
  cout << "TempDir: \"" << TempDir << "\"\n";
  cout << "VDRroot: \"" << VDRroot << "\"\n";
  cout << "DstDir: \"" << DstDir << "\"\n";
}


int cConfig::FillOneMatrix(String CompleteConfig, cMatrix MatrixName)
{
    int i;
    String Str;
    String OneVal;
    switch (MatrixName)
    {
	case mCDSize:
	    Str=ReadCfg(CompleteConfig,"CDSize");
	    break;
	case mNumCDs:
	    Str=ReadCfg(CompleteConfig,"NumCDs");
	    break;
        case mFiles:
	    Str=ReadCfg(CompleteConfig,"Files");
	    break;
        case mMVR_MP3:
	    Str=ReadCfg(CompleteConfig,"MVR_MP3");
	    break;
	case mMVR_AC3:
	    Str=ReadCfg(CompleteConfig,"MVR_AC3");
	    break;
	default:
	    cerr << "*** Fatal: Internal Programm error - FillOneMatrix called\n";
	    cerr << "    with unknown Matrix Number \"" << MatrixName << "\" :-(";
	    return 0;
    }
    if (Str=="")
    {
	cerr << "*** Fatal: 2divx.conf Parameter " << MatrixName << " not found!\n";
	return 0;
    };
    i=0;
    while (i<MaxBMM && strlen(Str) > 0)
    {
	OneVal=Str.before(RXwhite);
	if (OneVal=="") OneVal=Str;
	switch (MatrixName)
	{
	    case mCDSize:
		BMM.CDSize[i]=atoi((const char *) OneVal);
		break;
	    case mNumCDs:
		BMM.NumCDs[i]=atoi((const char *) OneVal);
		break;
	    case mFiles:
		BMM.Files[i]=atoi((const char *) OneVal);
		break;
	    case mMVR_MP3:
		BMM.MVR_MP3[i]=atoi((const char *) OneVal);
		break;
	    case mMVR_AC3:
		BMM.MVR_AC3[i]=atoi((const char *) OneVal);
		break;
	    default:
		cerr << "*** Fatal: Internal Programm error - FillOneMatrix called\n";
		cerr << "    with unknown Matrix Name \"" << MatrixName << "\" :-(";
		return 0;
	}
	Str=Str.after(RXwhite);
	i++;
    }
    return i;
}

bool cConfig::ConfFile()
// Read all parameter from 2divx.conf
// Return TRUE if everything went well, otherwise return FALSE!
{
    int i;
    char OneChar;
    bool Comment;
    ifstream InFile;
    String Str;
    String OneVal;
    String _2divx_conf;	 //Complete 2divx.conf without comments !

// Open 2divx.conf file (DOES exist, since CheckEnv in main did proof this!)
    InFile.open ("2divx.conf", ifstream::in);

    Comment=false;    
    _2divx_conf="";
    while (InFile.good())
    {
	OneChar = (char) InFile.get();
	if (Comment)
	{
	    if (OneChar=='\n')
		Comment=false;	// End of Comment line	
	}
	else
	{
	    if (OneChar=='#')
		Comment=true;
	    else
		_2divx_conf+=OneChar;	// read one Char from conf file!
	}
    }
    InFile.close();
    
// Read in Bitrate Media Matrix (BMM) - and do light consistency check    

    BMM.Columns=FillOneMatrix(_2divx_conf,mCDSize);
    if (BMM.Columns==0) return false;

    i=FillOneMatrix(_2divx_conf,mNumCDs);
    if (i!=BMM.Columns)
    {
	cerr << "*** Fatal: Your Bitrate Media Matrix in 2divx.conf seems corrupt - existing.\n";
	return false;
    }
    
    i=FillOneMatrix(_2divx_conf,mFiles);
    if (i!=BMM.Columns)
    {
	cerr << "*** Fatal: Your Bitrate Media Matrix in 2divx.conf seems corrupt - existing.\n";
	return false;
    }
    
    BMM.Columns_MP3=FillOneMatrix(_2divx_conf,mMVR_MP3);
    if (BMM.Columns_MP3 > BMM.Columns)
    {
	cerr << "*** Fatal: 2divx.conf - MP3 Matrix must not have more Columns than Media.\n";
	return false;
    }    

    BMM.Columns_AC3=FillOneMatrix(_2divx_conf,mMVR_AC3);
    if (BMM.Columns_AC3 > BMM.Columns)
    {
	cerr << "*** Fatal: 2divx.conf - AC3 Matrix must not have more Columns than Media.\n";
	return false;
    }    
    if (BMM.Columns_MP3 < BMM.Columns && BMM.Columns_AC3 < BMM.Columns)
    {
	cout << "*** Warning: MP3 and AC3 Matrix have less columns than Media !\n";
	cout << "***   although this is not a problem, it might be a config mistake !?\n";
    }
// BMM read in - Columns (_MP3, _AC3) contain number of used columns !

// Read in DefaultBitrate and check for range error!
    Str=ReadCfg(_2divx_conf,"DefaultBitrate");
    if (Str=="")
	cout << "*** Warning: No DefaultBitrate set in 2divx.conf - defaulting to 1380kbit/s\n";
    else
    {
	i=atoi((const char *)Str);
	if (i<100 || i>6000)
	    cout << "*** Warning: DefaultBitrate in 2divx.conf = " << i << "kbit/s out of range ...\n";
	else
	    DefaultBitrate=i;
    }

// Read in TempDir
    Str=ReadCfg(_2divx_conf,"TempDir");
    if (Str!="")
	TempDir=Str.before(RXwhite);
    if (TempDir[strlen(TempDir)-1]!='/') // make sure path has trailing "/"
	TempDir=TempDir+"/";
    if (!FileExist((const char *) TempDir))
    {
	cout << "*** Info: TempDir \"" << TempDir << "\" could not be found creating...\n";
	i=system("mkdir "+TempDir);
	if (i!=0)
	{
	    cerr << "*** Fatal: TempDir as specified in 2divx.conf could not be created!\n";
	    return false;
	}
    }    
// Read in VDRroot
    Str=ReadCfg(_2divx_conf,"VDRroot");
    if (Str!="")
	VDRroot=Str.before(RXwhite);
    if (VDRroot[strlen(VDRroot)-1]!='/') // make sure path has trailing "/"
	VDRroot=VDRroot+"/";
    if (!FileExist((const char *) VDRroot))
    {
	cout << "*** Warning: VDR Root \"" << VDRroot << "\" could not be found\n";
    }    
// Read in DstDir
    Str=ReadCfg(_2divx_conf,"DstDir");
    if (Str!="")
	DstDir=Str.before(RXwhite);
    if (DstDir[strlen(DstDir)-1]!='/') // make sure path has trailing "/"
	DstDir=DstDir+"/";
    if (!FileExist((const char *) DstDir))
    {
	cout << "*** Info: Destination Dir \"" << DstDir << "\" could not be found creating...\n";
	i=system("mkdir "+DstDir);
	if (i!=0)
	{
	    cerr << "*** Fatal: DstDir as specified in 2divx.conf could not be created!\n";
	    return false;
	}
    }    


// Read in external executables - if not defined in 2divx.conf, we use
//  defaults defined in cConfig::cConfig - all must be in search path of OS !
// Read in [path/]name_of_java_executable
    Str=ReadCfg(_2divx_conf,"Java");
    if (Str!="")
	Java=Str.before(RXwhite);
    if (!FileExist((const char *) Java))
    {
	cerr << "*** Fatal: java could not be found as: \"" << Java << "\"\n";
	return false;
    }
    
// Read in DsJar	    
    Str=ReadCfg(_2divx_conf,"DsJar");
    if (Str!="")
	DsJar=Str.before(RXwhite);
    if (!FileExist((const char *) DsJar))
    {
	cerr << "*** Fatal: ds.jar could not be found as: \"" << DsJar << "\"\n";
	return false;
    }
    	
// Read in Lame
    Str=ReadCfg(_2divx_conf,"Lame");
    if (Str!="")
        Lame=Str.before(RXwhite);
    if (!FileExist((const char *) Lame))
    {
	cerr << "*** Fatal: lame could not be found as: \"" << Lame << "\"\n";
	return false;
    }

// Read in Mencoder
    Str=ReadCfg(_2divx_conf,"Mencoder");
    if (Str!="")
        Mencoder=Str.before(RXwhite);
    if (!FileExist((const char *) Mencoder))
    {
	cerr << "*** Fatal: mencoder could not be found as: \"" << Mencoder << "\"\n";
	return false;
    }


// Read in orther stuff


    return true;
}


// Searches for OptionToFind in Configuration String
String ReadCfg(String CompleteConfig, String OptionToFind)
{
    String Str;

    if (!CompleteConfig.contains(OptionToFind))
	return ("");
    Str=CompleteConfig.after(OptionToFind);
    Str=Str.after(RXwhite);
    Str=Str.through("\n");	// including New Line (RXwhite)
    
    return Str;
};

