
// see main 2divx.cpp for copyright and author information.

#include "../Config.h"
#include "../Video.h"
#include "../FileExist.h"
#include "../System.h"

#include "dmx_dsjar.h"
	
bool dmx_dsjar(const cConfig Config, cVideo &pSrcVideo)
{

    void CleanUp_dsjar(cConfig Config); // local Celanup

        int i;
	String Str;
// Fireup ds.jar to demux the source file(s)	
	cout << "*** Info: Starting ds.jar to demux source file(s) - please be patient\n";
	Str="nice -n 10 "+Config.Java+" -jar \""+Config.DsJar+"\""
	    +" -c ds.ini -o \""+Config.TempDir+"\" -l";
	// Assemble string containing all VDR files!
	for (i=1; i<=pSrcVideo.NumFiles; i++)
	{
	    Str=Str+" \""+pSrcVideo.Path+IntToString(i,3)+".vdr\"";
	}
	i=system(Str);
	if (i!=0)
	{
	cout << "*** Fatal: Calling Java Environment with ds.jar caused some error (" << i << ") - exiting\n";
	    return false;
	}	    
// Check for demuxed files
// FIXME - here we should analyse for AC3 and multiple audio streams...
// Hint: It seems ds.jar *always* creates 001.mp2 and 001.mpv from 00*.vdr
//	 The Logfile is named 001_ds.jar.log
	
	if (!FileExist((const char *) (Config.TempDir+"001.mp2")))
	{
	    cerr << "*** Fatal: No Audio stream after demuxing :-( - Exiting.\n";
	    return false;
	}

	if (!FileExist((const char *) (Config.TempDir+"001.mpv")))
	{
	    cerr << "*** Fatal: No Video stream after demuxing :-( - Exiting.\n";
	    return false;
	}
	pSrcVideo.InSync=true; // assume we have fixed a/v sync !

	CleanUp_dsjar(Config);
	return true;
}

void CleanUp_dsjar(cConfig Config)
{
    int i;
    if ((!Config.Debug.nodelete)
	&& FileExist(Config.TempDir+"001_ds.jar.log"))
    {
	i=system("rm \""+Config.TempDir+"001_ds.jar.log\"");
	if (i!=0)
	{
	    cout << "*** Warning: Could not delete unused files- error (" << i << ")\n";
	    cout << "***          Make sure you have sufficient rights in TempDir!\n";
	}	    
    }
}



