
// see main 2divx.cpp for copyright and author information.


#include "../FileExist.h"
#include "../Video.h"
#include "../Config.h"
#include "../System.h"
#include "ven_mencoder.h"

bool ven_mencoder(const cConfig Config, cVideo &pSrcVideo, cVideo &pDstVideo)
{
    void CleanUp_menc(cConfig Config);
	int i,j,k;
	String Str;
// Fire up Mencoder to reencode Video and read in freshly encoded audio stream	
	cout << "*** Info: Starting mencoder to reencode video stream - please be patient\n";	
	Str="nice -n 10 "+Config.Mencoder+" -mc 0 -oac copy -ovc lavc"+
	    " -passlogfile \""+Config.TempDir+"divx2pass.log\""+
	    " -lavcopts vcodec=mpeg4:vhq:ildct:vpass=1:vqmin=2:vbitrate="+
	    IntToString(pDstVideo.VBitrate,0)+
	    ":aspect=4/3"+
	    " -audiofile \""+Config.TempDir+"001.mp3\""+
	    " \""+Config.TempDir+"001.mpv\""+
	    " -o \""+Config.TempDir+"test.avi\"";
//debug:	cout << Str << "\n";	    
	cout << "*** Info: Beginning Pass 1 ...\n";
	i=system(Str);
	if (i!=0)
	{
	cout << "*** Fatal: Calling Mencoder caused some error (" << i << ") - exiting\n";
	    CleanUp_menc(Config);
	    return false;
	}	    

	if (!FileExist((const char *) (Config.TempDir+"test.avi")))
	{
	    cerr << "*** Fatal: No AVI created by Mencoder :-( - Exiting.\n";
	    CleanUp_menc(Config);
	    return false;
	}

	cout << "*** Info: Beginning Pass 2 ...\n";
	// prepare string for second pass !
	// FIXME:
	// This way its easier, but Risk is that if Filename or something 
	// contains :vpass1: - it's changed :-(((
	// solution 2 half strngs or so...
	if (Str.gsub(":vpass=1:",":vpass=2:")!=1)
	{
	    cerr << "*** Fatal: internal Error while preparing pass2\n";
	    CleanUp_menc(Config);
	    return false;
	}
	i=system(Str);
	if (i!=0)
	{
	cout << "*** Fatal: Calling Mencoder caused some error (" << i << ") - exiting\n";
	    CleanUp_menc(Config);
	    return false;
	}	    

	if (!FileExist((const char *) (Config.TempDir+"test.avi")))
	{
	    cerr << "*** Fatal: No AVI created by Mencoder :-( - Exiting.\n";
	    CleanUp_menc(Config);
	    return false;
	}

	CleanUp_menc(Config);
	return true;
}

void CleanUp_menc(cConfig Config)
{
// Remove unneeded files ...
    int i,j,k;
    i=j=k=0;
    if (!Config.Debug.nodelete)
    {
	if (FileExist(Config.TempDir+"001.mp3"))
	    i=system("rm \""+Config.TempDir+"001.mp3\"");
	if (FileExist(Config.TempDir+"001.mpv"))    
	    j=system("rm \""+Config.TempDir+"001.mpv\"");
	if (FileExist(Config.TempDir+"divx2pass.log"))
	    k=system("rm \""+Config.TempDir+"divx2pass.log\"");
	if ( i!=0 || j!=0 || k!=0 )
	{
	    cout << "*** Warning: Could not delete unused files- error (" << i << ")\n";
	    cout << "***          Make sure you have sufficient rights in TempDir!\n";
	}	    
    }
}

